/*  функции Дерева эпизодической памяти



 */


package psychic

import "BOT/lib"

//////////////////////////////////////////////////////////////////////
/* Вытащить из эпизод.памяти посленюю цепочку кадров типа (kind=) 0 - объективная память, 1 - субъективная, -1 любая
чтобы использовать ее как шаблон для поиска правил.
Не стоит задавать limit больше 5-10 (оптимизируется)
*/
func getLastSequenceFromEpisodeMemory(kind int, limit int)([]int){
	ln:=len(EpisodicHistoryArr)
		if(ln<limit) {
			limit = ln - 1
		}
		return EpisodicHistoryArr[(ln-limit):]
}
/////////////////////////////////////////////////////////////////




/* Найти все ID узлов EpisodicTreeNode для которых выполняется условие
Пpедсказание эффекта от Action для данных условий
level == 0 - для всех трех деревьев условий (NodeAID,NodeSID,NodePID)
level == 1 - для двух первых деревьев условий (NodeAID,NodeSID)
level == 2 - только для дерева автоматизмов

Значение Trigger определеяется обязательно, обычно это curStimulImageID
Значение Action может быть ==0 и тогда результат покажет возможные варианты ответов на Trigger
Если определены Trigger и Action, то результат оказывается предсказанием того, какоц эффект будет при Action.

- ДЛЯ ТЕКУЩИХ СТИМУЛА (Trigger) Ответ (Action) не определен - его и нужно найти подходящий
 */
var ePsrsIdArr []int
var onlyOldExperience = false // true - игнорировать узлы, созданные ранее, чем 60 сек назад
func getEpisodesArrFromConditions(level int,Trigger int,Action int)[]int{
	if Trigger==0{
		lib.TodoPanic("НУЛЕВОЙ ПАРАМЕТР Trigger!")
		return nil
	}
	oldOnly:=onlyOldExperience// true - игнорировать узлы, созданные ранее, чем 60 сек назад
	onlyOldExperience = false

	ePsrsIdArr=nil

	switch level {
	case 0:
		cond:= []int{detectedActiveLastNodID,
			detectedActiveLastUnderstandingNodID,
			detectedActiveLastProblemNodID,
			Trigger,}

	//	 cond= []int{67,38,107,1,}; //Action=3

		id, _ := findEpisodicBrange(0, cond, &EpisodicTree)
		if id==0{ return nil}
		lib.MapCheckBlock(MapGwardEpisodicTreeNodeFromID)
		node, ok := EpisodicTreeNodeFromID[id]
		lib.MapFree(MapGwardEpisodicTreeNodeFromID)
		if !ok {return nil	}
		for i := 0; i < len(node.Children); i++ {
			if node.Children[i].Trigger !=Trigger{
				continue
			}
			if Action>0 && node.Children[i].Action !=Action{
				continue
			}
			if oldOnly && isEarlyNode(&node.Children[i]){
				continue
			}
			ePsrsIdArr=append(ePsrsIdArr,node.Children[i].ID)
		}
		return ePsrsIdArr

	case 1:
		cond:= []int{detectedActiveLastNodID,
			detectedActiveLastUnderstandingNodID,} // нужно выделять только те, у которых Trigger==curStimulImageID
		//cond= []int{67,38,}; Trigger=1; Action=3

		id, _ := findEpisodicBrange(0, cond, &EpisodicTree)
		if id==0{ return nil}
		lib.MapCheckBlock(MapGwardEpisodicTreeNodeFromID)
		node, ok := EpisodicTreeNodeFromID[id]
		lib.MapFree(MapGwardEpisodicTreeNodeFromID)
		if !ok {return nil	}

		getIdArr(node,Trigger,Action,oldOnly)
		return ePsrsIdArr

	case 2:
		cond:= []int{detectedActiveLastNodID,} // нужно выделять только те, у которых Trigger==curStimulImageID

		// cond= []int{67,}

		id, _ := findEpisodicBrange(0, cond, &EpisodicTree)
		if id==0{ return nil}
		lib.MapCheckBlock(MapGwardEpisodicTreeNodeFromID)
		node, ok := EpisodicTreeNodeFromID[id]
		lib.MapFree(MapGwardEpisodicTreeNodeFromID)
		if !ok {return nil	}
		getIdArr(node,Trigger,Action,oldOnly)
		return ePsrsIdArr
	}

return nil
}
// вытащить все ID узлов, в которых есть условие, начиная с node
func getIdArr(node *EpisodicTreeNode,Trigger int,Action int,oldOnly bool){
	for _, child := range node.Children {

		if len(child.PARAMS)>0 { // узел с прописанным PARAMS
			if Trigger>0 && child.Trigger !=Trigger{
				continue
			}
			if Action>0 && child.Action !=Action{
				continue
			}
			if oldOnly && isEarlyNode(&child){
				continue
			}
			ePsrsIdArr=append(ePsrsIdArr,child.ID)
		}
			// продолжим рекурсивно искать в нем далее
			getIdArr(&child,Trigger,Action,oldOnly)
	}

	return
}
// в PARAMS узла есть только один эффект, записанный ранее, чем 60 сек назад
func isEarlyNode(node *EpisodicTreeNode)bool{
	pars:=node.PARAMS
	if len(pars)==0{
		return true // так не должно быть, но если что пусть считает негодным
	}
	for n := 0; n < len(pars); n++ {
		if LifeTime - pars[n][1] > 60{
			return false // есть старый параметр
		}
	}
	return true // нет старых параметров
}
//////////////////////////////////////////////////////////////////




/* получить приемлемую последовательность id EpisodicTreeNode от данного Trigger
в виде глобального массива targetEpisodicStrIdArr цепочек Правил.
Назовет ее целевой последовательностью, т.е. если на данный Trigger отвечать targetEpisodicStrIdArr[0]
а опертор ответит EpisodicTreeNodeFromID[targetEpisodicStrIdArr[1]].Trigger и т.д.
то придем к тому позитивному результату, который прогнозировался при получении targetStrIdArr.
Если оператор ответит непредсказуемо, то нужно снова вызвать getTargetEpisodicStrIdArr(EpisodicTreeNodeFromID[targetEpisodicStrIdArr[1]].Trigger)
и получить скорректированную последовательность.

targetStrIdArr состояит из зафиксированных ранее непрерывных цепочек в EpisodicHistoryArr,
между которыми прошло не более timeBetween (20 сек) (проверка по PARAMS.LifeTime)

При поиске избегать узлов со временем появления, менее, чем 60 сек т.к. нужен опыт прошлого.

Пример вызова: getTargetEpisodicStrIdArr(TriggerID,5,20)
 */
var targetEpisodicStrIdArr []Rule // окончательно выбранная целевая цепочка Правил
var episodicStrIdArr [][]Rule // несколько найденных целевых цепочек Правил
func getTargetEpisodicStrIdArr(Trigger int,limit int,timeBetween int){

	targetEpisodicStrIdArr=nil
	episodicStrIdArr=nil

	if timeBetween<20{ timeBetween=20}

// попытка найти в точном соотвествии с условиями
	onlyOldExperience =true// только менее, чем 60 сек
	nArr:=getEpisodesArrFromConditions(0,Trigger,0)
	if nArr==nil{
		onlyOldExperience =true// только менее, чем 60 сек
		nArr=getEpisodesArrFromConditions(1,Trigger,0)
	}
	if nArr==nil{
		onlyOldExperience =true// только менее, чем 60 сек
		nArr=getEpisodesArrFromConditions(2,Trigger,0)
	}
	if nArr==nil{// нет никакого опыта с Trigger
		return
	}
	/////////////////////////////////////////

	/* искать цепочки подряд идущих эпизодов, начинающиеся с данного nArr[i],
	  кончающиеся хорошим эффектом и собирать их targetEpisodicStrIdArr[]
	Значение limit пока ==5 но может оптимизироваться (TODO)
	 */
	for i := 0; i < len(nArr); i++ {
		getEpisodicStrIdArr(nArr[i],5,timeBetween)
	}

	if episodicStrIdArr!= nil{
		if len(episodicStrIdArr)>1{// нашли несколько, нужно выбрать лучшую из episodicStrIdArr
			// targetEpisodicStrIdArr=append(targetEpisodicStrIdArr, XXXX)

		}else{// единственная
			targetEpisodicStrIdArr=append(targetEpisodicStrIdArr, episodicStrIdArr[0][0])
		}
	}
}
/* искать цепочки подряд идущих эпизодов исторической последовательности эпизодов EpisodicHistoryArr
начинающихся с данного nArr[i],
кончающиеся хорошим эффектом и вернуть их в массиве targetEpisodicStrIdArr[]
 */
func getEpisodicStrIdArr(id int,limit int,timeBetween int){
	// последний индекс исторической памяти EpisodicHistoryArr[]
	lastI:=len(EpisodicHistoryArr)-1
	var node *EpisodicTreeNode
	lastTime:=0// LifeTime последнего найденного эпизода для сравнения со следующим (не должен превышать timeBetween сек)
	var strIdArr []Rule // для формирования цепочки Правил
	for i := lastI; i >= 0; i-- {
		if EpisodicHistoryArr[i] == id {
			// начиная с i посмотреть что там дальше и сформировать цепочку
			endStr:=false
			negative:=0// значение негативного Правила, которое м.б. в цепоске с более позитивным концом
			for n := i; n < lastI || (n-i) < limit; n++ {
				if endStr{// конец формирования цепочки Правил
					break
				}
				lib.MapCheckBlock(MapGwardEpisodicTreeNodeFromID)
				node=EpisodicTreeNodeFromID[EpisodicHistoryArr[i]]
				lib.MapFree(MapGwardEpisodicTreeNodeFromID)
				pars:=node.PARAMS
				if len(pars)==0{
					continue
				}
				for p := 0; p < len(pars); p++ {// lastTime==0 для самого первого
					if lastTime==0 || (pars[p][1] - lastTime) < timeBetween{
						// смотрим эффект
						if pars[p][0] >0{
							if negative <0{// было негативное Правило
								if pars[p][0] > - negative{// нет выигрыша, пусть продолжает искать
									continue
								}
							}
							// добавить Правило
							rule:=Rule{node.Trigger,node.Action,pars[p][0]}
							strIdArr=append(strIdArr,rule)
							endStr=true // закончить цепочку Правил
							break
						}
						if pars[p][0] <0{
							// продолжаем смотреть, а не будет ли дальше +эффект лучший, чем этот минус
							negative=pars[p][0]
						}
					}
				}//for p := 0; p < len(pars); p++ {
			}//for n := i; n < lastI || (n-i) < limit; n++ {
			if strIdArr!=nil && len(strIdArr)>0{
				episodicStrIdArr=append(episodicStrIdArr,strIdArr)
			}
		}//if EpisodicHistoryArr[i] == id {
	}//for i := lastI; i > 0; i-- {

return
}
////////////////////////////////////////////////////////////////////




